package satmenuwrapper;

import android.view.ext.SatelliteMenu;
import android.view.ext.SatelliteMenuItem;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.BA.Events;
import android.view.MotionEvent;

import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewParent;

import android.graphics.BitmapShader;
import android.graphics.Shader;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.RectShape;

import android.view.ext.SatelliteMenu.SateliteClickedListener;

import android.view.ext.R;

import java.util.ArrayList;
import java.util.List;



@Author("Johan Schoeman")
@Version(1.00f)
@ShortName("SatelliteMenu")
public class satMenuWrapper extends ViewWrapper<SatelliteMenu> implements DesignerCustomView  {


	private BA ba;
	private String eventName;
        private SatelliteMenu cv;
 
	
	/*
	 * Initialize the HTML-TextView 
	 */   


	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new SatelliteMenu(ba.context);
                this.setObject(cv);
//                addListener();
 	}


//    @Hide
//    public void addListener(){
//        cv.setCallback(new StartPointSeekBar.Callback() {
//            @Override
//            public void value_changed() {

//              if (ba.subExists(eventName + "_value_changed")) {
//                ba.raiseEvent2(ba, false, eventName + "_value_changed", true, new Object[0]);
//              }
//            }

//            @Override
//            public void started() {

//              if (ba.subExists(eventName + "_started")) {
//                ba.raiseEvent2(ba, false, eventName + "_started", true, new Object[0]);
//              }
//            }


//        });
//    }


	
	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}

	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}

    public void setDrawableNames(String[] draw) {

             List<SatelliteMenuItem> items = new ArrayList<SatelliteMenuItem>(); 
             for (int i = 0; i < draw.length; i++) {
		int DrawableID = BA.applicationContext.getResources().getIdentifier(draw[i], "drawable", BA.packageName);
		Drawable drawable = BA.applicationContext.getResources().getDrawable(DrawableID);
                items.add(new SatelliteMenuItem(i, drawable));
             }
             cv.addItems(items); 

             cv.setOnItemClickedListener(new SateliteClickedListener() {
			
			public void eventOccured(int id) {

                                if (ba.subExists(eventName + "_satelite_clicked")) {
                                    ba.raiseEvent2(ba, false, eventName + "_satelite_clicked", true, new Object[]{id});
                                }


			}
	     });

                 
    }


	/**
	 * Defines the total space between the initial and final item in degrees.
	 * Note: Calling before adding items is strongly recommended.
	 * 
	 * @param totalSpacingDegree The degree between initial and final items. 
	 */
	public void setTotalSpacingDegree(float totalSpacingDegree) {
		cv.setTotalSpacingDegree(totalSpacingDegree);
		cv.invalidate();
	}

	/**
	 * Sets the distance of items from the center in pixels.
	 * Note: Calling before adding items is strongly recommended.
	 * 
	 * @param distance the distance of items to center in pixels.
	 */
	public void setSatelliteDistance(int distance) {
		cv.setSatelliteDistance(distance);
		cv.invalidate();
	}

	/**
	 * Sets the duration for expanding and collapsing the items in miliseconds. 
	 * Note: Calling before adding items is strongly recommended.
	 * 
	 * @param expandDuration the duration for expanding and collapsing the items in miliseconds.
	 */
	public void setExpandDuration(int expandDuration) {
		cv.setExpandDuration(expandDuration);
		cv.invalidate();
	}
	

	/**
	 * Sets the image drawable for the center button.
	 * 
	 * @param resource The image drawable.
	 */
//	public void setMainImage(String drawable) {
//		cv.setMainImage(drawable);
//                cv.invalidate();
//	}

	/**
	 * Defines if the menu shall collapse the items when an item is clicked. Default value is true. 
	 * 
	 * @param closeItemsOnClick
	 */
	public void setCloseItemsOnClick(boolean closeItemsOnClick) {
		cv.setCloseItemsOnClick(closeItemsOnClick);
                cv.invalidate();
	}
	

	/**
	 * Expand the menu items. 
	 */
	public void expand() {
		cv.expand();
//                cv.invalidate();
	}

	/**
	 * Collapse the menu items
	 */
	public void close() {
		cv.close();
//                cv.invalidate();
	}








}
